// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package shop

import (
	"context"
	"errors"

	"juwan-backend/app/shop/api/internal/svc"
	"juwan-backend/app/shop/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetUserShopLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// 获取店长的店铺
func NewGetUserShopLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetUserShopLogic {
	return &GetUserShopLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetUserShopLogic) GetUserShop(req *types.UserIdReq) (resp *types.ShopProfile, err error) {
	shop, err := getShopByOwnerID(l.ctx, l.svcCtx.ShopRpc, req.Id)
	if err != nil {
		return nil, err
	}
	if shop == nil {
		return nil, errors.New("shop not found")
	}
	return toShopProfile(shop), nil

}
